; 
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm
; 
    .data
      xx    dd 123456789
      yy    dd 0
      fpucw dw 0
    .code
; 
start:
; 
    finit

    invoke Sleep, 3000

    fstcw fpucw
    print "Control word PC field = "
    movzx eax, fpucw
    shr eax, 8
    and eax, 11b
    print uhex$(eax),"h (default, 64 bits)",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      fild xx
      fsqrt
      fistp yy
    counter_end
    print ustr$(eax)," cycles",13,10

    ; -------------------------------------------------------
    ; Set the PC field in the control word to 10b = 53 bits,
    ; then read the value back and display it.
    ; -------------------------------------------------------

    fstcw fpucw
    and fpucw, not 0100000000b
    fldcw fpucw
    fstcw fpucw
    print "Control word PC field = "
    movzx eax, fpucw
    shr eax, 8
    and eax, 11b
    print uhex$(eax),"h (53 bits)",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      fild xx
      fsqrt
      fistp yy
    counter_end
    print ustr$(eax)," cycles",13,10

    ; -------------------------------------------------------
    ; Set the PC field in the control word to 00b = 24 bits,
    ; then read the value back and display it.
    ; -------------------------------------------------------

    fstcw fpucw
    and fpucw, not 1100000000b
    fldcw fpucw
    fstcw fpucw
    print "Control word PC field = "
    movzx eax, fpucw
    shr eax, 8
    and eax, 11b
    print uhex$(eax),"h (24 bits)",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      fild xx
      fsqrt
      fistp yy
    counter_end
    print ustr$(eax)," cycles",13,10

    finit

    inkey "Press any key to exit..."
    exit
; 
end start
 